# Copyright © 2019 Vladimir Arnautov aka PharmCat (mail@pharmcat.net)

function info(;io::IO = Base.stdout)
    println(io, "")
    println(io, "Package name: ClinicalTrialUtilities")
    println(io, "Clinical Trial Power and Sample Size Utilities")
    println(io, "Copyright © 2019 Vladimir Arnautov aka PharmCat (mail@pharmcat.net)")
    println(io, "For references, citations and copyrights run: ClinicalTrialUtilities.citation()")
    println(io, "Licence: ClinicalTrialUtilities.licence()")
    println(io, "")
end

function citation(;io::IO = Base.stdout)
    println(io, "References:")
    println(io, "")
    println(io, "PowerTOST Authors©R :Detlew Labes (DetlewLabes@gmx.de), Helmut Schuetz (helmut.schuetz@bebac.at), Benjamin Lang (lang.be@icloud.com)")
    println(io, "")
    println(io, "Chow S., Shao J., Wang H. 2008. Sample Size Calculations in Clinical Research. 2nd Ed. Chapman & Hall/CRC Biostatistics Series.")
    println(io, "")
    println(io, "Connor R. J. 1987. Sample size for testing differences in proportions for the paired-sample design. Biometrics 43(1):207-211. page 209.")
    println(io, "")
    println(io, "Owen D. B. 1965. \"A Special Case of a Bivariate Non-central t-Distribution\" Biometrika Vol. 52, pp.437-446.")
    println(io, "")
    println(io, "Owen D. B. 1956. \"Tables for computing bivariate normal Probabilities\" The Annals of Mathematical Statistics, Vol. 27 (4) Dec. 1956, pp. 1075-1090")
    println(io, "")
    println(io, "Burkhardt J. FORTRAN and Matlab code used for PowerTOST R Package")
    println(io, "")
    println(io, "Wilson E. B. 1927. \"Probable inference, the law of succession, and statistical inferenceJ.\" Amer.Stat. Assoc22, 209–212")
end

function licence(;io::IO = Base.stdout)
    println(io, "")
    println(io, "Licence:")
    println(io, "GNU Affero General Public License v3.0")
    println(io, "see <https://www.gnu.org/licenses/>")
    println(io, "")
end
